<?php
/*  Copyright (c) 2005 CaseySoftware, LLC

    This file is a module for dotProject.

    This file is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License Version 2
	as published by the Free Software Foundation.

    This file is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    Modified by Thomas Zander Version 1.3 thomas-zander@arcor.de
*/
	include_once('xml.inc.php');

	$output .= 'Using MSProject import plugin.';

	function import()
	{
		global $AppUI;

		$q = new DBQuery();

		if (!empty($_POST['new_company']))
		{
			$q->addTable('companies');
			$q->addInsert('company_name', $_POST['new_company']);
			$q->addInsert('company_owner', $AppUI->user_id);
			$q->exec();
			$output .= 'New Company created: ' . $_POST['new_company'] . '<br>';
			$company_id = db_insert_id();
		}
		else
			$company_id = $_POST['company_id'];

		$q->clear();
		$q->addTable('projects');
		$q->addInsert('project_name', $_POST['project_name']);
		$q->addInsert('project_short_name', substr($_POST['project_name'], 0, 8));
		$q->addInsert('project_company', $company_id);
		$q->addInsert('project_start_date', $_POST['project_start_date']);
		$q->addInsert('project_end_date', $_POST['project_end_date']);
		$q->addInsert('project_owner', $AppUI->user_id);
		$q->exec();

		$project_id = db_insert_id();

		// Users Setup
		foreach($_POST['users'] as $ruid => $r)
		{
			if (empty($r['user_id']))
			{
				$space = strrpos($r['user_username'], ' ');
				if ($space === false)
				{
					$first_name = '';
					$last_name = $r['user_username'];
				} else {
					$first_name = substr($r['user_username'], 0, $space);
					$last_name = substr($r['user_username'], $space + 1);
				}
				$q->clear();
				$q->addTable('contacts');
				$q->addInsert('contact_first_name', $first_name);
				$q->addInsert('contact_last_name', $last_name);
				$q->addInsert('contact_order_by', $r['user_username']);
				$q->exec();
				$contact_id = db_insert_id();
				$q->clear();
				$q->addInsert('user_username', $r['user_username']);
				$q->addInsert('user_contact', $contact_id);
				$q->addTable('users');
				$q->exec();
				$insert_id = db_insert_id();

				$r['user_id'] = $insert_id;
			}

			if (!empty($r['user_id']))
				$resources[$ruid] = $r;
		}

		// Tasks Setup
		foreach ($_POST['tasks'] as $k => $task)
		{
			$q->clear();
			$q->addInsert('task_project', $project_id);
			$q->addInsert('task_name', $task['task_name']);
			$q->addInsert('task_description', $task['task_description']);
			$q->addInsert('task_priority', $task['task_priority']);
			$q->addInsert('task_start_date', $task['task_start_date']);
			$q->addInsert('task_end_date', $task['task_end_date']);
			$q->addInsert('task_duration', $task['task_duration']);
			$q->addInsert('task_milestone', $task['task_milestone']);
			$q->addInsert('task_owner', $task['task_owner']);
			$q->addInsert('task_dynamic', $task['task_dynamic']);
			$q->addInsert('task_priority', $task['task_priority']);
			$q->addInsert('task_description', $task['task_description']);
			$q->addInsert('task_percent_complete', $task['task_percent_complete']);
			$q->addInsert('task_duration_type', 1);
			$q->addTable('tasks');
			$q->exec();

			$task_id = db_insert_id();

			// Task Parenthood
			$outline[$task['OUTLINENUMBER']] = $task_id;
			$q->clear();
			if (!strpos($task['OUTLINENUMBER'], '.'))
			{
				$q->addUpdate('task_parent', $task_id);
				$q->addWhere('task_id = ' . $task_id);
				$q->addTable('tasks');
			}
			else
			{
				$parent_string = substr($task['OUTLINENUMBER'], 0, strrpos($task['OUTLINENUMBER'], '.'));
				$parent_outline = $outline[$parent_string];
				$q->addUpdate('task_parent', $parent_outline);
				$q->addWhere('task_id = ' . $task_id);
				$q->addTable('tasks');
			}
			$q->exec();

			$_POST['tasks'][$k]['task_id'] = $task_id;
			$task['task_id'] = $task_id;

			// Resources (Workers)
			$tasks[$task['UID']] = $task;

			foreach($task['resources'] as $uk => $user)
			{
				$alloc = $task['resources_alloc'][$uk];
				$q->clear();
				$q->addInsert('user_id', $resources[$user]['user_id']);
				$q->addInsert('task_id', $task_id);
				$q->addInsert('perc_assignment', $alloc);
					//$q->addInsert('user_task_priority', 0);
				$q->addTable('user_tasks');
				$q->exec();
			}

			// Task Dependencies
			if (is_array($task['dependencies']))
			foreach($task['dependencies'] as $task_uid)
			{
				if ($task_uid > 0 && $tasks[$task_uid]['task_id'] > 0)
				{
					$q->clear();
					$q->addInsert('dependencies_task_id', $task_id);
					$q->addInsert('dependencies_req_task_id', $tasks[$task_uid]['task_id']);
					$q->addTable('task_dependencies');
					$q->exec();
				}
			}
		}

		return $output;
	}

	function preview($data)
	{
		global $AppUI;

		$output = '';

		$q = new DBQuery();

		$tree = xmlParse($data);
		$tree = rebuildTree($tree);
		$tree = $tree['PROJECT'][0];

		$output .= '
<table width="100%">
<tr>
	<td align="right">' . $AppUI->_('Company') . ':</td>';

		require_once $AppUI->getModuleClass('companies');
		$companyClass =& new CCompany;

		$company = $tree['COMPANY'];
		$q->addQuery('company_id');
		$q->addTable('companies');
		$q->addWhere("company_name like '$company'");
		$company_id = $q->loadResult();

		$q->clear();
		$q->addQuery('company_id, company_name');
		$q->addTable('companies');
		$q->addWhere($companyClass->getAllowedSQL($AppUI->user_id));
		$q->addOrder('company_name');
		$companies = $q->loadHashList();
		$companies[0] = '';
		$output .= '
	<td>
		' . arraySelect($companies, 'company_id', ' onChange=this.form.new_company.value=\'\'', $company_id) . '
		<input type="text" name="new_company" value="' . (($company_id > 0)?'':$company) . '" />
	</td>
</tr>';

		$output .= '
<tr>
	<td align="right">' . $AppUI->_('Project') . ':</td>';
		$project_name = $tree['TITLE'];
		if (empty($project_name))
			$project_name = $tree['NAME'];
		if (strstr($project_name, "."))
			$project_name = substr($project_name, 0, strrpos($project_name, '.'));

		$q->clear();
		$q->addQuery('project_id');
		$q->addTable('projects');
		$q->addWhere("project_name like '$project_name'");
		$project_match = $q->loadResult();

		$output .= '
	<td><input type="text" name="project_name" value="' . $project_name . '" />';
		if ($project_match)
			$output .= $AppUI->_('pexist') ; //, do you want to overwrite? <input type="checkbox" name="project_over" value="true"> yes)';
		$output .= '</td>
</tr>';


		$output .= '
<tr>
	<td align="right">' . $AppUI->_('Start Date') . ':</td>
	<td><input type="text" name="project_start_date" value="' . $tree['STARTDATE'] . '" /></td>
</tr>
<tr>
	<td align="right">' . $AppUI->_('End Date') . ':</td>
	<td><input type="text" name="project_end_date" value="' . $tree['FINISHDATE'] . '" /></td>
</tr>
<tr>
	<td colspan="2">' . $AppUI->_('Users') . ':</td>
</tr>';

		// Users (Resources)
		$resources = array();
		foreach($tree['RESOURCES'][0]['RESOURCE'] as $r)
		{
			// print_r($r);
			$q->clear();
			$q->addQuery('user_id');
			$q->addTable('users');
			$q->leftJoin('contacts', 'c', 'user_contact = contact_id');
			$q->addWhere("user_username LIKE '{$r['NAME']}' OR CONCAT_WS(contact_first_name, ' ', contact_last_name) = '{$r['NAME']}'");
			$r['LID'] = $q->loadResult();
			if (!empty($r['NAME']))
			{
				$output .= '
<tr>
	<td>' . $AppUI->_('User name') . ': </td>
	<td>
		<input type="text" name="users[' . $r['UID'] . '][user_username]" value="' . $r['NAME'] . '"' . (empty($r['LID'])?'':' readonly') . ' />
		<input type="hidden" name="users[' . $r['UID'] . '][user_id]" value="' . $r['LID'] . '" />
		(' . $AppUI->_('Resource') . ' UID ' . $r['UID'] . ')
	</td>
</tr>';
				$resources[$r['UID']] = $r['NAME'];
			}
		}

		// Insert Tasks
		$output .= '
<tr>
	<td colspan="2">' . $AppUI->_('Tasks') . ':</td>
</tr>
<tr>
	<td colspan="2">
	<table width="100%">
	<tr>
		<th></th>
		<th>' . $AppUI->_('Name') . '</th>
		<th>' . $AppUI->_('Start Date') . '</th>
		<th>' . $AppUI->_('End Date') . '</th>
		<th>' . $AppUI->_('user allocations') . '</th>
	</tr>';
		foreach($tree['TASKS'][0]['TASK'] as $k => $task)
		{
			if ($task['UID'] != 0) // project itself
			{
				$task['DURATION'] = dur($task['DURATION']);
				$tasklevel = substr_count($task['OUTLINENUMBER'], '.');
				$output .= '
	<tr>
		<td>
			<input type="hidden" name="tasks['.$k.'][UID]" value="' . $task['UID'] . '" />
			<input type="hidden" name="tasks['.$k.'][OUTLINENUMBER]" value="' . $task['OUTLINENUMBER'] . '" />
			<input type="hidden" name="tasks['.$k.'][task_name]" value="' . $task['NAME'] . '" />
			<input type="hidden" name="tasks['.$k.'][task_description]" value="' . $task['NOTES'] . '" />
			<input type="hidden" name="tasks['.$k.'][task_priority]" value="' . $task['PRIORITY'] . '" />
			<input type="hidden" name="tasks['.$k.'][task_start_date]" value="' . $task['START'] . '" />
			<input type="hidden" name="tasks['.$k.'][task_end_date]" value="' . $task['FINISH'] . '" />
			<input type="hidden" name="tasks['.$k.'][task_duration]" value="' . $task['DURATION'] . '" />
			<input type="hidden" name="tasks['.$k.'][task_percent_complete]" value="' . $task['PERCENTCOMPLETE'] . '" />
			<input type="hidden" name="tasks['.$k.'][task_description]" value="' . $task['NOTES'] . '" />
			<input type="hidden" name="tasks['.$k.'][task_priority]" value="' . $task['PRIORITY'] . '" />
			<input type="hidden" name="tasks['.$k.'][task_dynamic]" value="' . $task['TYPE'] . '" />
			<input type="hidden" name="tasks['.$k.'][task_owner]" value="1" />
			<input type="hidden" name="tasks['.$k.'][task_milestone]" value="' . $task['MILESTONE'] . '" />';
				$temp = 0;
				if (is_array($task['PREDECESSORLINK']))
				foreach ($task['PREDECESSORLINK'] as $dependency)
				{
					$output .= '<input type="hidden" name="tasks['.$k.'][dependencies][]" value="' . $dependency['PREDECESSORUID'] . '" />'; //'.$k.'-'.$temp.'
					++$temp;
				}

				$output .= '
		</td>
		<td>';
				for($i = 0; $i < $tasklevel; $i++)
					$output .= dPshowImage(dPfindImage('corner-dots.gif')) . '&nbsp;';

				$output .= $task['NAME'] . '<br /><hr />'.$task['NOTES'] . '<hr size="2" /></td>
		<td>' . $task['START'] . '</td>
		<td>' . $task['FINISH'] . '</td>
		<td>';

				foreach($tree['ASSIGNMENTS'][0]['ASSIGNMENT'] as $a) {
					if ($a['TASKUID'] == $task['UID']) {
						$output .= arraySelect($resources, 'tasks['.$k.'][resources][]', '', $a['RESOURCEUID']);
                        if ($task['DURATION'] > 0) {
                            $perc = 100 * $a['UNITS'];
                        }

                        $output .= '<input type="text" name=tasks['.$k.'][resources_alloc][]" value="' . sprintf("%.0f", $perc) . '" size="3" />%<br />';
					}
				}

				$output .= '
		</td>
	</tr>';
			}
		}
		$output .= '
	</table>
	</td>
</tr>';

		$output .= '
</table>';
		return $output;
	}

	function dur($duration)
	{
		return substr($duration, 2, strpos($duration, 'H', 0) - 2);
	}
?>